local jkCiderProduction = ...

-- Growing Setup -------------------------------------------------------------------------------------
jkCiderProduction:register({
    DataType = "AGENT_WORKSTATION_SETUP",
    Id = MOD_NS .. "AGENT_WORKSTATION_SETUP_APPLE_FARM_GROWING",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
		IdleAnimation = "MARKET_TENDER"
	}
})

-- Sowing Setup -------------------------------------------------------------------------------------
jkCiderProduction:register({
    DataType = "AGENT_WORKSTATION_SETUP",
    Id = MOD_NS .. "AGENT_WORKSTATION_SETUP_APPLE_FARM_SOWING",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
		IdleAnimation = "MARKET_TENDER"
	}
})

-- Harvest Setup -------------------------------------------------------------------------------------
jkCiderProduction:register({
    DataType = "AGENT_WORKSTATION_SETUP",
    Id = MOD_NS .. "AGENT_WORKSTATION_SETUP_APPLE_FARM_HARVEST",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
		IdleAnimation = "MARKET_TENDER"
	}
})

jkCiderProduction:register({
	DataType = "JOB",
	Id = MOD_NS .. "JOB_ORCHARDIST",
	JobName = "JOB_ORCHARDIST_NAME",
	JobDescription = "JOB_ORCHARDIST_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_FARMER",
    ProductionDelay = 5.0,
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
		WalkAnimation = "WALKING",
		IdleAnimation = "MARKET_TENDER"
	}
})

jkCiderProduction:register({
    DataType = "BUILDING_FUNCTION_FARM",
    Id = "BUILDING_FUNCTION_APPLE_FARM",
    Name = "BUILDING_FUNCTION_ORCHARD_NAME",
	WorkerCapacity = 3,
	InputInventoryCapacity = {{ Resource = "RESOURCE_APPLE", Quantity = 200 }},
    RelatedJob = { 
        Job = MOD_NS .. "JOB_ORCHARDIST", 
        Behavior = "BEHAVIOR_FARMER"
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_APPLE", Quantity = 1 },
	},
	ResourceProduced = {
        { Resource = "RESOURCE_APPLE", Quantity = 1 },
    },

    -- there is a max total cycle of 21 days so if you plan beyond that, it will be cut short
    SowingDurationPerc = {0, 1},
	GrowDuration = {1, 3}, 
	GrowWaitDuration = {3, 4},
	HarvestDuration = {4, 10},
	RestDuration = {10, 21},

    QuantityToHarvestPerStep = 1,
	HarvestStepsCount = 3,
	ResourceValuePerGather = 1,

    QuantityToPlantPerStep = 0,
	PlantingStepsCount = 0,

    CropFieldConfig = MOD_NS .. "FARM_FIELD_CONFIG_APPLE_FARM",
    GrowingSetup = MOD_NS .. "AGENT_WORKSTATION_SETUP_APPLE_FARM_GROWING", 
    SowingSetup = MOD_NS .. "AGENT_WORKSTATION_SETUP_APPLE_FARM_SOWING", 
    HarvestSetup = MOD_NS .. "AGENT_WORKSTATION_SETUP_APPLE_FARM_HARVEST"
})

jkCiderProduction:register({ 
	DataType = "BUILDING_FUNCTION_WORKPLACE",
	Id = MOD_NS .. "BREWER_FUNCTION",
	WorkerCapacity = 1,
	RelatedJob = { Job = "BREWER", Behavior = "BEHAVIOR_WORK" },
	InputInventoryCapacity = {{ Resource = "RESOURCE_APPLE", Quantity = 200 }},
	ResourceListNeeded = {{ Resource = "RESOURCE_APPLE", Quantity = 2 }},
	ResourceProduced = {{ Resource = "RESOURCE_CIDER", Quantity = 1 }}
})

local overridenNewcomerCompatibleJobList = {
	Action = "APPEND",
	MOD_NS .. "JOB_ORCHARDIST"
}
jkCiderProduction:override({ Id = "NEWCOMER", CompatibleJobList = overridenNewcomerCompatibleJobList })

local overridenOtherCompatibleJobList = {
	Action = "APPEND",
	MOD_NS .. "JOB_ORCHARDIST"
}
jkCiderProduction:override({ Id = "SERF", CompatibleJobList = overridenCompatibleJobList })
jkCiderProduction:override({ Id = "COMMONER", CompatibleJobList = overridenCompatibleJobList })
jkCiderProduction:override({ Id = "CITIZEN", CompatibleJobList = overridenCompatibleJobList })